Bug 463873 - [LTC 6.0 FEAT] 201196:Idle CPU power management
[LTC 6.0 FEAT] 201196:Idle CPU power management
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: kernel (Show other bugs)
All All
high Severity high
: alpha
: 6.0
Assigned To: Jesse Larrew
Zhang Kexin
: FutureFeature, OtherQA
Depends On:
Blocks: 356741 515068 519960 525727 554546 554559 555224 555228 575278
  Show dependency treegraph
Reported: 2008-09-24 23:00 EDT by IBM Bug Proxy
Modified: 2013-01-10 02:57 EST (History)
8 users (show)

See Also:
Fixed In Version: kernel-2.6.32
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2010-11-15 09:07:57 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description IBM Bug Proxy 2008-09-24 23:00:29 EDT
=Comment: #0=================================================
Emily J. Ratliff <emilyr@us.ibm.com> - 2008-09-24 13:54 EDT
1. Feature Overview:
Feature Id:	[201196]
a. Name of Feature:	Idle CPU power management
b. Feature Description
Arbitrary kernel timer events, user space polling and interrupts wake otherwise idle CPUs,
shortening the CPU idle time.  By instead moving to more asynchronous notifications for various
applications and device subsystems instead of using regular timer based wake-ups/polling, the time
spent by a CPU in lower C states during idle can be increased.  Similarly scheduling of tasks with
active timers to active CPUs allows idle CPUs to remain idle and in low power state.

2. Feature Details:
Sponsor:	LTC

Arch Specificity: Both
Affects Core Kernel: Yes
Delivery Mechanism: Direct from community
Category:	Kernel
Request Type:	Kernel - Enhancement from Upstream
d. Upstream Acceptance:	In Progress
Sponsor Priority	1
f. Severity: High
IBM Confidential:	no
Code Contribution:	IBM code
g. Component Version Target:	unknown
Performance Assistance:	yes

3. Business Case
Increasingly the enterprise market is interested in mitigating and managing power consumption in
servers, where interest previously was mostly in a mobile market.  Driving optimizations in the
power consumption area allows an enterprise Linux distribution advantages over other operating
systems in this emerging market.

4. Primary contact at Red Hat: 
John Jarvis

5. Primary contacts at Partner:
Project Management Contact:
Sarah Wright, sarahw@us.ibm.com, 503-578-5145

Technical contact(s):
Dipankar Sarma, dipankar.sarma@in.ibm.com
Gautham R Shenoy, gautshen@in.ibm.com

IBM Manager:
Jeffrey Heroux, heroux@us.ibm.com
Comment 1 Bill Nottingham 2008-10-03 13:27:10 EDT
We've done some work on this already in userspace in Fedora (using the powertop program to point out offenders.) 

While we have no problem with the feature, there's nothing specific listed here that is actionable other than 'test and see what is causing wakeups and polling'.

Are there specific instances you know of that you'd like fixed?
Comment 2 IBM Bug Proxy 2009-03-03 04:10:32 EST
This feature is to do with power-savings through task-consolidation, which is a scheduler feature offered through the interfaces sched_mc_power_savings and sched_smt_power_savings.

There has been enhancements to the existing interface, which was earlier boolean, but now has been made multi-valued to represent the aggressiveness of consolidation to obtain power savings. This feature is accepted in linux-2.6.29.

1) http://git.kernel.org/gitweb.cgi?p=linux/kernel/git/torvalds/linux-2.6.git;a=commit;h=afb8a9b70b86866a60e08b2956ae4e1406390336
2) http://git.kernel.org/gitweb.cgi?p=linux/kernel/git/torvalds/linux-2.6.git;a=commit;h=d5679bd11916eba5c8ee9033003e1a5ce56ece9a
5) http://git.kernel.org/gitweb.cgi?p=linux/kernel/git/torvalds/linux-2.6.git;a=commit;h=36dffab679c7eeb91c2507400cf4da6e9e01164e

Further enhancements to the accepted code have been discussed in the community (Ref: http://lkml.org/lkml/2009/2/16/221)

In addition, there are other scheduler enhancements which are under discussion such as
- the timer-migration framework discussed (Ref: http://lkml.org/lkml/2009/2/20/121)
- Idle Load Balancer enhancements (Ref:http://lkml.org/lkml/2008/9/23/82 )
Comment 3 Bill Nottingham 2009-03-03 17:42:34 EST
OK, marking as MODIFIED.

The feature requested has already been accepted into the upstream code base
planned for the next major release of Red Hat Enterprise Linux.

When the next milestone release of Red Hat Enterprise Linux 6 is available,
please verify that the feature requested is present and functioning as
Comment 4 IBM Bug Proxy 2009-11-18 07:50:46 EST
Since this is in RH cvs tree, moving to Accepted state here
Comment 5 IBM Bug Proxy 2009-11-18 09:01:18 EST
------- Comment From sglass@us.ibm.com 2009-11-18 08:53 EDT-------
Testing that this message will get over to the RH bug

Please ignore
Comment 7 IBM Bug Proxy 2010-06-07 07:00:38 EDT
------- Comment From arunbharadwaj@in.ibm.com 2010-06-07 06:59 EDT-------
Marking this as verified as the dependant bugs https://bugzilla.linux.ibm.com/show_bug.cgi?id=52943 , https://bugzilla.linux.ibm.com/show_bug.cgi?id=52944 ,
https://bugzilla.linux.ibm.com/show_bug.cgi?id=52945 have been verified on RHEL 6 snapshot 1
Comment 8 Petr Beňas 2010-10-08 05:03:13 EDT
code review... patches 1,4 and 5 from comment 2 are applied in 2.6.32-15.el6 source. No code from patches 2 and 3 found in the kernel source. Neither the surrounding code found, so I guess it was deleted, moved somewhere else.
Comment 9 releng-rhel@redhat.com 2010-11-15 09:07:57 EST
Red Hat Enterprise Linux 6.0 is now available and should resolve
the problem described in this bug report. This report is therefore being closed
with a resolution of CURRENTRELEASE. You may reopen this bug report if the
solution does not work for you.

Note You need to log in before you can comment on or make changes to this bug.